type RobotController = Robot -> WheelControl
type VelocityController = Robot -> VelocityControl
type SteeringController = Robot -> SteeringControl
type RobotTracker a = Robot-> Tracker a

&&&: SteeringController -> VelocityController -> RobotController

--- Proportional control

pcontrol: Num a => val -> val -> val -> val
pcontrol gain setpoint sval = gain * (setpoint - sval)

--- Proportional control using something that gives a "position"
--- in optical coordinates (doesn't have to be video ...)

homing: Pos -> SteeringControl
homing possrc =  - pcontrol 1.0 0.0 Pos.x
          
--- Now, a package deal; we need a way of combining component
--- controllers in an appropriate sense


vishoming: VelocityController -> RobotTracker Pos -> Controller
vishoming vel src = 
   \r -> ((src r) >>> ((toSP1 (homing vel) &&& (vel r)))

--- Now presumably this all fits with the other robotstuff in terms of
--- guarded moves and all

safehome: VelocityController -> RobotTracker Pos -> Controller
safehome rmotion tracker = (vishoming rmotion track) 
                                `guardedby` 
                           (proximity | collision)

--- How do we deal with mistracking and/or blending obstacle avoidance 

--- In general, should we have "exceptions, or just events --- for example how
--- should we deal with mistracking?

--- 